#!/sw/bin/python
#!/usr/local/bin/python
#!/usr/bin/python

import Image, ImageFile
import thsfunctions

def _accept(prefix):
    return ord(prefix[0]) == int(0xF0)

class PaintImageFile(ImageFile.ImageFile):

    format = "PAINT"
    format_description = "Paint Format data"
    
    def _open(self):
        header_offset = 5;
        
        header = self.fp.read(header_offset)
        if ord(header[0]) != int(0xF0):
            raise SyntaxError, "Not a Paint file"

        width = ((ord(header[1]) << 8) + ord(header[2]))
        height = ((ord(header[3]) << 8) + ord(header[4]))
        self.size = width, height
        
        self.mode = "RGB"
        
        self.tile = [("raw", (0,0)+self.size, header_offset, (self.mode, 0, 1))]
        
Image.register_open(PaintImageFile.format, PaintImageFile)
Image.register_extension(PaintImageFile.format, ".pnt")