package paint;
//
//  cgio.java
//  treehousedraw
//
//  Created by john maeda on Thu Aug 15 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

import java.io.*;
import java.net.*;

import java.awt.*;
import java.applet.*;
import java.util.*;

public class cgio implements Runnable {
    Applet app;
    int plen; // pixel length

    String name ="image.raw";

    boolean errorp = false;

    String hostname;
    int hostport;
    String hostcgipath = "";

    public boolean successp = false;
    Thread engine = null;
    boolean donep = true;
    public long sleep = 10;
    String errstr = "";
    boolean sendp = false;
    long startt;

    public void mystart()
    {
   try{
        start();
   } catch (Exception e) {
    System.out.println("when starting got: "+e);
    }
    }

    public void mystop()
    {
        stop();
    }

    public void start() throws Exception {
        try {
            System.out.println("Started thread.");
            engine = new Thread(this); engine.start();
            engine.setPriority(Thread.MIN_PRIORITY);
            successp = false;
            donep = false;
            startt = System.currentTimeMillis();
        } catch (Exception e) {
            System.out.println("when started got this: "+e);
            successp = false;
            donep = false;
            startt = System.currentTimeMillis();
            throw(e);
        }
    }

    public boolean readwritep()
    { return !donep;}

    byte []senddata;
    int senddatalen;
    String sendfile;
    
    public boolean trysendthread(byte dat[], int datlen, String datfile)
    {
        if (!donep)
            return false;
        donep = false;
        killit();
        successp = false;
        sendp = true;
        senddata = dat;
        senddatalen = datlen;
        sendfile = datfile;
        try {
            mystart();
        } catch (Exception e) {
            System.out.println("Msg: cannot thread write, doing non-threaded ...");

            return false;
        }
        return true;
    }

    String pickupcmd = "th_read.py";//"olget.pl","mon=8&yr=1997&det=3");
    String pickupqs = "mon=8&yr=1997&det=3";
    String pickupres = "";

    public String getpickupreceipt()
    {
        return pickupres;
    }

/*
    int cbw, cbh;
    public boolean getlineentry(String folder, int entry, int w, int h)
    {
        cbw = w; cbh = h;

        System.out.println("glt: "+folder+", entry: "+entry);
        setindex(entry);

        return trypickupthreadwithcmd("olget.pl","yrmon="+folder+"&det="+entry,true);
    }
*/
    public boolean trypickupnothread(String cmd, String fname)
    {
        pickupcmd = cmd;
        pickupqs = "name="+fname;
        successp = false;
        donep = false;

        return dopickup();
    }


    public boolean trypickupthreadwithcmd(String cmd, String qs)
    {
        System.out.println("tptwc: "+cmd+"/"+qs);

        pickupcmd = cmd;
        pickupqs = qs;
        successp = false;

        if (!donep)
            return false;
        donep = false;
        killit();

        sendp = false;
        pickupreq = true;

        try {
            mystart();
        } catch (Exception e) {
            System.out.println("Msg: cannot thread pickup, doing non-threaded ...");

            return false;
        }
        return true;
    }

    public void killit()
    {
        if ((engine != null) && engine.isAlive()) {
             //engine.stop();
             mystop();
             //engine = null;
             //System.out.println("engine killed properly");
        }
    }

    boolean pickupreq = false;
    boolean cancelp = false;

    public void run() {

        while(true) {
            //if (!disabledp) {

            if (sendp) {
                successp = dosend(senddata,senddatalen,sendfile);
                donep = true;
                mystop();
            } else {
                if (pickupreq) {
                    pickupreq = false;
                    successp = dopickup();
                    donep = true;
                    mystop();
                }
            }
            //}
            try{ Thread.sleep(sleep); } catch(InterruptedException e) {
                System.out.println("**Exception: "+e);
                donep = true; successp = false; this.stop(); }
        }
    }

    public void stop() {
        System.out.println("stopped");

        if ((engine != null) && engine.isAlive()) {
             engine.stop();
             System.out.println("about to kill engine.");
             engine = null;
             System.out.println("engine killed");
        }
    }

    public boolean firewallcheckp()
    {
        String home = hostname;
        String rdata = ""; // where all the result data goes
        int port = hostport;
 //       port = 80;

        msg("*Commencing firewall connection test to "+home+" on port "+port);
        msg("*Cleared test if next message is 'OK'.");

	             Socket           sock;
             OutputStream     outp;
             InputStream      inp;
             DataOutputStream dataout;
             DataInputStream  datain;

			// msg("Status: Connecting to "+home+" ...");

             try {
                 sock = new Socket(home, port); //msg("Status: Opened.");
             }

             catch (Exception e)
             {
                 rdata = e+" (socket: Host: "+home+"\tPort: "+port+")"; //msg("Error in instantiating socket.");
                 System.out.println(rdata); return false;
             }

             // Obtain output stream to communicate with the server

             try
             {
                // msg("Status: Opening socket i/o.");
                outp = sock.getOutputStream();
                 inp  = sock.getInputStream(); msg("Status: Opened.");
             }
             catch (Exception e)
             {
                 rdata = e+" (getstream)";// msg("Error in opening sockets i/o.");
                 System.out.println(rdata);
                 try { sock.close();
                 } catch (IOException ee) {} return false;
             }

             try
             {
                 //msg("Status: Opening data i/o.");
                 dataout = new DataOutputStream(outp);
                 datain  = new DataInputStream(inp); msg("Status: Opened.");
             }
             catch (Exception e)
             {
                 rdata = e+" (Dstream)"; //msg("Error in opening data i/o.");
                 System.out.println(rdata);
                 try { sock.close(); } catch (IOException ee){} return false;
             }

             try {
             datain.close();
             sock.close();
             } catch (Exception e) {
                return false;
             }

             msg("OK.");
             return true;
    }

    public int pickupdatalen = 0;
    public byte []pickupdata;

    public int sendid, sendlen;

    public void st(String s)
    {
      System.out.println(s);
    }
    
    public void err(String s) { st("Error: "+s);}
    
    public boolean dosend(byte[] myb, int nbytes, String tofile)
    {
        String res;

        successp = false;
        errorp = false;
        String qs = "name="+tofile;
        
        st("********>> tranporting "+nbytes+" bytes ...");

        res = sendcgi("th_write.py",qs,myb,nbytes);
        msg(res);
        // should parse result to determine if successful or not
        if (res!=null) {
            // clear out old line
            st("msg is: ("+res+")");
            if (res.startsWith("*")) {
               st("successful -> started with a '*'");
               //  errorp = true;
            } else {
                err(res); // no good
                errorp = true;
                return false;
            }
            return true; // not accurate
        } else
            return false;
    }

    public boolean dopickup()
    {
        String res;

        successp = false;
        cancelp= false;
        
        res = pickupcgi(pickupcmd, pickupqs);

        if (res!=null) {
            pickupres = res;
            st("pickupres is: "+res);
            return true;
        } else {
            err("dopickup unsuccessful with res null");
            return false;
        }

    }

    void msg(String s) { st(s); }
    
    String ctype  = "application/octet-stream";

    // returns a receipt
    // as a convention, send an int (4 bytes) that has the length at the start
     public String sendcgi(String script, String querystr, byte [] data, int datalength)
    {
             Socket           sock;
             OutputStream     outp;
             InputStream      inp;
             DataOutputStream dataout;
             DataInputStream  datain;
              String receipt="";
             String rdata = ""; // where all the result data goes

             String home = hostname;
             int port = hostport;

             script = hostcgipath+script;

             System.out.println("Query is: "+querystr+", script is: "+script);
             msg("Status: Connecting to "+home+" ...");

             try {
                 sock = new Socket(home, port); msg("Status: Opened.");
             }

             catch (Exception e)
             {
                 rdata = e+" (socket: Host: "+home+"\tPort: "+port+")"; msg("Error in instantiating socket.");
                 System.out.println(rdata); return null;
             }

             // Obtain output stream to communicate with the server

             try
             {
                 msg("Status: Opening socket i/o."); outp = sock.getOutputStream();
                 inp  = sock.getInputStream(); msg("Status: Opened.");
             }
             catch (Exception e)
             {
                 rdata = e+" (getstream)"; msg("Error in opening sockets i/o.");
                 System.out.println(rdata);
                 try { sock.close();
                 } catch (IOException ee) {} return null;
             }

             try
             {
                 msg("Status: Opening data i/o.");
                 dataout = new DataOutputStream(outp);
                 datain  = new DataInputStream(inp); //msg("Status: Opened.");
             }
             catch (Exception e)
             {
                 rdata = e+" (Dstream)"; //msg("Error in opening data i/o.");
                 System.out.println(rdata);
                 try { sock.close(); } catch (IOException ee){} return null;
             }

             // Send http request to server and get return data

             try
             {
                 msg("Status: Submitting data to server.");
                // script = "/vars.pl.cgi";
               // querystr = "vars.pl.cgi";
                String submitstr = "POST " + script+"?"+querystr + " HTTP/1.0\r\n";
             //   submitstr = "GET " + script+"?"+querystr + " HTTP/1.0\r\n";
 //               System.out.println(submitstr);

              msg("Writing out "+datalength+" bytes.");

                 dataout.writeBytes(submitstr);
                 dataout.writeBytes("Content-type: " + ctype + "\r\n");

                 dataout.writeBytes("Content-length: " + (datalength + 4) + "\r\n");

                 System.out.println("contentlen is "+(datalength+4));
                 dataout.writeBytes("\r\n");         // end of header
           //      dataout.writeInt(0x00ff00ff);
                 dataout.writeInt(datalength);
                 dataout.write(data,0,datalength);
                 dataout.writeBytes("\r\n");         // end of header
             msg("OK.");
                 /*
                  * Data has been submitted
                  * all that is left is to check to see if the data went out
                  * okay by checking to see what came bac
                  * from the server
                  *
                  */

                 int bodyc=0;
                 boolean body = false;
                 String line;

                 msg("Retrieving receipt ...");
                 while ((line = datain.readLine()) != null)
                 {
//                  System.out.println(">> "+line);
 //                   System.out.println("data line is: "+line);
                    if (body)
                     receipt = receipt+line+"\n";
                    if (line.equals("")) { bodyc++; if (bodyc==2) body=true; }// start gettinb body
                 }
                 msg("Done.");
             }
             catch (Exception e)
             {
                 rdata = e+" (write)";
                 msg("Error -- unable to submit.");
                 System.out.println("Error. Failure. "+rdata);
                 try {
                     sock.close();
                 } catch (IOException ee){}
                 return null;
             }

             // close up shop

             try
             {
                 dataout.close();
                 datain.close();
             }
             catch (IOException e) {}
             try {
                 sock.close();
            }  catch (IOException e) {}

         //   System.out.println("receipt is: \n"+receipt);
            return receipt;
    }

    public void sp(String s){System.out.println(s);}
    public void injectcancel() { cancelp = true; }
    public String pickupcgi(String script, String querystr)
	{
             Socket           sock;
             OutputStream     outp;
             InputStream      inp;
             DataOutputStream dataout;
             DataInputStream  datain;
             String home = hostname;
             int port = hostport;

             boolean res = false;
		     String sdata="pickup";
		     String receipt = "";

             String rdata = "";

             script = hostcgipath+script;

             if (cancelp) {msg("Cancelling"); return "";}

			 msg("Connecting to "+home+" ...");
             //create a client socket

             try{msg("Opening socket ...");sock = new Socket(home, port);msg("Done.");if (cancelp) {msg("Cancelling"); return "";}}
             catch (Exception e){
                 rdata = e+" (socket: Host: "+home+"\tPort: "+port+")";msg("Error opening socket.");System.out.println(rdata);
                 return null;}

             // Obtain output stream to communicate with the server

             try{msg("Opening socket i/o ...");outp = sock.getOutputStream();inp  = sock.getInputStream();msg("Done.");if (cancelp) {msg("Cancelling"); return "";}}
             catch (Exception e)
             {
                 rdata = e+" (getstream)"; msg("Error opening socket i/o.");System.out.println(rdata);
                 try {sock.close();} catch (IOException ee) {}
                 return null;
             }

             try  {msg("Opening data i/o ..."); dataout = new DataOutputStream(outp);  datain  = new DataInputStream(inp);msg("Done.");if (cancelp) {msg("Cancelling"); return "";};
             }
             catch (Exception e)
             {  rdata = e+" (Dstream)"; msg("Error opening data i/o.");
                 System.out.println(rdata);
                 try { sock.close(); } catch (IOException ee){} return null;
             }

             // Send http request to server and get return data

             try
             {
             	int totallen;
                 msg("Posting request to server.");
              	System.out.println("***qs is "+querystr+", script is: "+script);
 if (cancelp) {msg("Cancelling"); return "";}
                 dataout.writeBytes("POST " + script+"?"+querystr + " HTTP/1.0\r\n");
                 dataout.writeBytes("Content-type: " + ctype + "\r\n");

                 dataout.writeBytes("Content-length: " + sdata.length()+ "\r\n");
                 dataout.writeBytes("\r\n");         // end of header
                 // POST data
                 dataout.writeBytes(sdata); // not really used
                 dataout.writeBytes("\r\n");
if (cancelp) {msg("Cancelling"); return "";}

                 boolean body = false;
                 String line;
                 int bodyc = 0;
                 System.out.println("Begin read");
                 msg("Starting read ...");
                 while ((line = datain.readLine()) != null)
                 {
                    System.out.println("line: "+line);
 //                   	System.out.println(line);
                     if (cancelp) {msg("Cancelling"); return "";}
                     if (line.equals("")) {
                        bodyc++;
                        if (bodyc==2)
                           body = true;
                     } else if (body)
                     {
                     	msg("Authenticating ...");
                        //rdata += "\n" + line;
 //                       line = datain.readLine();
                        sp("got a line: "+line);
                        // first line shoudl return a '*' to validate transfer
                        // assume that first line with '*' means good
                        if (line.charAt(0)!='*') {
                        	msg("Access was denied.");//("Unsuccessful");
                      	    while ((line = datain.readLine()) != null)
                      		    receipt=receipt+line+"\n";
                      		res= false;
                        } else {
                            msg("Access has been authorized with ."+line);
                           // sp("doing readint");
                           {
                              String s = datain.readLine();
                              pickupdatalen = (Integer.valueOf(s)).intValue();
                           }
//                            pickupdatalen = datain.readInt();
                            sp("back");
                           msg("Read first int is "+b.length);
                 //           pickupdatalen = 59;

                            pickupdata = null;
                            pickupdata = new byte[b.length];
                            msg("Reading "+b.length+" bytes.");

                            datain.readFully(pickupdata,0,b.length);
                            receipt += "Successfully read "+b.length+" bytes.";
	                  	    msg(receipt);
	                  	    res= true;
	                  	}
 	                  	break;
                    }
                 }
             }
             catch (Exception e)
             {
                 rdata = e+" (write)";
                 msg("Error in read.");
                 System.out.println(rdata);
                 try {
                     sock.close();
                 } catch (IOException ee){}
                 return null;
             }

             // close up shop

             try             {
                 dataout.close();
                 datain.close();
             }
             catch (IOException e) {}
             try {
                 sock.close();
            }  catch (IOException e) {}

         //   System.out.println("receipt is: "+receipt);
          	return (res?receipt:null);
 //        	System.out.println(rdata);
	}

   public cgio(Applet myapp) {
        boolean debugp = true;

        System.out.println("**** ONELINE INSTANTIATED");

        hostname = myapp.getDocumentBase().getHost();
        hostport = myapp.getDocumentBase().getPort();
        hostcgipath = "/CGI/";

        debugp = hostname.equals("");
        System.out.println("debugp "+debugp);
 //       debugp = true;
        String foo = app.getParameter("connectinfo");

        if (foo != null) {
            StringTokenizer st = new StringTokenizer(foo," ");
            connhost = st.nextToken();
            connname = st.nextToken();
            System.out.println("newconnslipped in: "+connhost+"@"+connname);
        }

        // hardwire

        debugp = true;

        if (debugp || hostport == -1) {
            msg("**Error cannot open host");
                 System.out.println("**Error: using debug settings for host");
            hostname="127.0.0.1";
            hostport = 80;
            hostcgipath = "/cgi-bin/";
        }

        System.out.println("host info is : ("+hostname+") on ["+hostport+"]");

        app = myapp;
   }
}

