//
//  SprayCanTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Sat Feb 01 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package paint;
import java.awt.*;
import treehouse.*;

public class SprayCanTool extends THSGeneralTool {
    
    public SprayCanTool() {
        super();
    }

    public String getIconImage() {
        return "painticon-1_spraycan.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Spray Can";
    }

    public boolean mouseDown(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.dospray(gi,mx,my);
        return true;
    }

    public boolean mouseDrag(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.dospray(gi,mx,my);
        return true;
    }

    public boolean mouseMove(int mx, int my, THSCanvas c) {
        return false;
    }
    
    public boolean mouseUp(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        Simple.dospray(gi,mx,my);
        return true;
    }

    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }

    
}
