package paint;

import java.applet.Applet;

import treehouse.*;

/**
 * @author mplanck
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class PaintIconPanel extends THSIconPanel {
    /**
        * Constructor for PaintIconPanel.
        * @param _x
        * @param _y
        * @param _w
        * @param _h
        * @param _app
        */
    public PaintIconPanel(
            int _x,
            int _y,
            int _w,
            int _h,
            Applet _app) {
            super(_x, _y, _w, _h, _app);
    }

    /**
     * This method initializes the IconPanel given the settings provided in integer form.  Note that any
     * implementation of another Applet should parse out tool information in this function. 
     **/
    public void setTools(int settings) {
        if (settings == 0) {
            disableTool(0);
            disableTool(1);
            disableTool(2);
            disableTool(4);
            disableTool(5);
            disableTool(6);
            disableTool(7);
            disableTool(8);
            disableTool(9);
            disableTool(10);
            disableTool(11);
            disableTool(12);
            disableTool(13);
            disableTool(14);
        } else {
            disableTool(1);
            disableTool(12);
            disableTool(14);
        }
    }
    
    public void initTools() {
        this.addTool(new LineTool());
        this.addTool(new TypeTool());
        this.addTool(new FillTool());
        this.addTool(new PencilTool());
        this.addTool(new BrushTool());
        this.addTool(new EraserTool());
        this.addTool(new SprayCanTool());
        this.addTool(new RectTool());
        this.addTool(new FilledRectTool());
        this.addTool(new OvalTool());
        this.addTool(new FilledOvalTool());
        this.addTool(new BlobTool());
        this.addTool(new FilledBlobTool());
        this.addTool(new PolygonTool());
        this.addTool(new FilledPolygonTool());
    }
}
